package reset;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;

/**
 * Cette classe est la classe qui gere l'affichage de l'element en tete de pile.
 * Cette classe implemente la classe actionListener, c'est donc elle qui servira a
 * gerer les evenements des boutons qu'elle contient.
 *
 * @version 1.14
 * @since 5/11/05
 * @author Olivio_Mariano
 */
class DisplayTop implements ActionListener{
    StackInterface itf;
	
/**
 * Cree le bouton d'affichage tu sommet de pile
 *
 * @param itf
 */
     public DisplayTop(StackInterface itf){
	this.itf = itf;
    }

	/**
     * Cree l'action resultante a partir d'une action
	 * effectu sur le bouton d'affichage du sommet de pile.
	 * La methode utilise une exeption 
	 * specifique dans cas d'une pile vide et n'ayant pas de sommet.
     */
    public void actionPerformed(ActionEvent e){
	try{
	    JOptionPane.showMessageDialog(itf,
					  "Top of the stack is : \n"+(String)itf.stackPanel.Stack.top(),
					  "Top of the stack",
					  JOptionPane.INFORMATION_MESSAGE);
	    itf.stackPanel.upDate();
	    itf.pack();
	}catch (EmptyStackException exc){
	    JOptionPane.showMessageDialog(itf, 
					  "No top at the moment. Please add an element to view a top", 
					  "Empty stack !", 
					  JOptionPane.ERROR_MESSAGE);
	}
    }
}
