package reset;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;

/**
 * Cette classe est la classe qui gere la creation d'une nouvelle pile. Cette classe implemente la 
 * classe actionListener, c'est donc elle qui servira a gerer les evenements des boutons qu'elle contient.
 *
 * @version 1.14
 * @since 5/11/05
 * @author Olivio_Mariano
 */
class NewStack implements ActionListener{
    StackInterface itf;
    
	/**
     * Cree le bouton pour creer une nouvelle pile
     *
     * @see StackInterface
	 */
    public NewStack(StackInterface itf){
	this.itf = itf;
    }

	/**
     * Cree l'action resultante a partir d'une action
	 * effectue sur le bouton de creation d'une
	 * nouvelle pile. La methode utilise une exeption 
	 * specifique dans le cas d'une valeur inseree incorrecte.
     *
     */
    public void actionPerformed(ActionEvent e){
	try{
	    itf.stackPanel.Stack = new Stack(new Integer(JOptionPane.showInputDialog(itf,"Custom stack size :")).intValue());
	    itf.inStack.setEnabled(true);
	    itf.outStack.setEnabled(true);
	    itf.topofStackDisplay.setEnabled(true);
	    itf.stackPanel.upDate();
	    itf.stackPanel.repaint();
	    itf.pack();
	}catch(Exception exc){
	     JOptionPane.showMessageDialog(itf, 
				       "Please enter a correct size", 
				       "Not a correct size", 
				       JOptionPane.ERROR_MESSAGE);
		}
    }
}
