package reset;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFileChooser;

/**
 * Cette classe est la classe qui gere l'ouverture d'un fichier xml contenant une pile. Cette classe implemente la 
 * classe actionListener, c'est donc elle qui servira a gerer les evenements des boutons qu'elle contient.
 *
 * @version 1.14
 * @since 5/11/05
 * @author Olivio_Mariano
 */
class OpenStack implements ActionListener{
  StackInterface itf;

   /**
     * Cree le bouton de ouverture d'un fichier.
     *
     * @see StackInterface
	 */
public OpenStack(StackInterface itf){
	this.itf = itf;
    }

/**
     * Cree l'action resultante a partir d'une action
	 * effectue sur le bouton d'ouverture d'une
	 * pile (au format xml) deja existante.
	 * La methode utilise une exeption 
	 * specifique dans cas d'une pile pleine
     *
     * @see JFileChooser
	 * @see FiltreFichier
     */
public void actionPerformed(ActionEvent e) {
try {
	JFileChooser choix = new JFileChooser();
	FiltreFichier filter = new FiltreFichier();
    filter.addExtension("xml");
    filter.setDescription("xml files only");
    choix.setFileFilter(filter);
	choix.showOpenDialog(itf);
	String fichier = "";
	fichier = choix.getSelectedFile().getAbsolutePath();
	Reader reader = new Reader();
	reader.starter(fichier,itf);
	itf.stackPanel.upDate();
	itf.stackPanel.repaint();
	itf.pack();
	}catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
		}
	}
}
