package reset;

import java.io.FileReader;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import javax.swing.*;
import javax.swing.border.LineBorder;
import java.util.LinkedList;
import java.lang.Exception;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

/**
 * Cette classe est la classe qui gere le parsing d'un fichier xml.
 *
 * @version 1.14
 * @since 5/11/05
 * @author Olivio_Mariano
 */
class MySAXApp extends DefaultHandler
{
	StackInterface itf;

    /** Locator reference. */
    Locator loc;
	
    public MySAXApp (StackInterface itf)
    {
	super();
	this.itf = itf;
    }

    public void characters (char ch[], int start, int length)
    {
	try{
    	Stack application = new Stack(100);
		String s = "";
			for (int i = start; i < start + length; i++) {
			/*System.out.print(ch[i]);*/
			
			s = s + String.valueOf(ch[i]);
			
			}
			if (s.length()>0){
				itf.stackPanel.Stack.inStack(s);}
		    }catch(Exception e1){ 

		}
	}
}

/**
 * Cette classe est la classe qui gere la lecture et la convertion d'un fichier xml.
 *
 * @version 1.14
 * @since 5/11/05
 * @author Olivio_Mariano
 */
public class Reader {

	/**
     * Lecture et conversion du fichier xml en entree.
     */
    public void starter (String file, StackInterface itf)
	throws Exception {
		try 
		{
	   SAXParserFactory spf = SAXParserFactory.newInstance();
	   spf.setNamespaceAware(true);
	   spf.setValidating(true);
		
	   // Create a JAXP SAXParser
           SAXParser saxParser = spf.newSAXParser();
		
	   XMLReader xr = saxParser.getXMLReader();
	   MySAXApp handler = new MySAXApp(itf);
	   xr.setContentHandler(handler);
	   xr.setErrorHandler(handler);
	   xr.setDTDHandler(handler) ;
	   xr.parse(file);
        } catch (Throwable t)
          {
            t.printStackTrace();
          }}
}