package reset;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;

/**
 * Cette classe est la classe qui gere l'elimination d'un element. Cette classe implemente la 
 * classe actionListener, c'est donc elle qui servira a gerer les evenements des boutons qu'elle contient.
 *
 * @version 1.14
 * @since 5/11/05
 * @author Olivio_Mariano
 */
class RmfStack implements ActionListener{
    StackInterface itf;
	
       /**
     * Cree le bouton d'elimination
	 */
     public RmfStack(StackInterface itf){
	this.itf = itf;
    }

	/**
     * Cree l'action resultante a partir d'une action
	 * effectuee sur le bouton d'elimination d'un element.
	 * La methode utilise une exeption 
	 * specifique dans cas d'une pile vide
     */
    public void actionPerformed(ActionEvent e){
	try{
	    itf.stackPanel.Stack.outStack();
	    itf.stackPanel.upDate();
	    itf.stackPanel.repaint();
	    itf.pack();
	}catch (EmptyStackException exc){JOptionPane.showMessageDialog(itf, 
				       "Empty Stack ! Cannot remove an element from an empty Stack !", 
				       "Empty Stack !", 
				       JOptionPane.ERROR_MESSAGE);}
    }
	    
}
