package reset;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

/**
 * Cette classe est la classe qui gere la sauvegarde d'une pile. Cette classe implemente la 
 * classe actionListener, c'est donc elle qui servira a gerer les evenements des boutons qu'elle contient.
 *
 * @version 1.14
 * @since 5/11/05
 * @author Olivio_Mariano
 */
class SaveStack implements ActionListener{
    StackInterface itf;
    
	/**
     * Cree le bouton de sauvegarde de la pile
     *
     * @see #SaveStack
	 */
    public SaveStack(StackInterface itf){
	this.itf = itf;
    }
	
	/**
     * Cree l'action resultante a partir d'une action
	 * effectue sur le bouton de sauvegarde d'une pile.
	 * La methode utilise une exeption 
	 * specifique dans le cas d'une pile vide.
     */
public void actionPerformed(ActionEvent args) {
    try {
      FileOutputStream fout = new FileOutputStream("pile.xml");
      OutputStreamWriter out = new OutputStreamWriter(fout);      

      out.write("<?xml version=\"1.0\"?>\r\n");
      out.write("<PILE_STRING>\r\n");  
      for (int i = 0; i < itf.stackPanel.Stack.getNeither().size(); i++) {
        out.write("  <ELEMENT index=\"" + i + "\">");
        out.write((String) itf.stackPanel.Stack.getNeither().get(i));
        out.write("</ELEMENT>\r\n");
      }
      out.write("</PILE_STRING>");  
 
      out.close();
    }
    catch (IOException e) {
      System.err.println(e);
    }

  }

}
