package reset;

import java.util.Iterator;
import java.util.LinkedList;

/**
 * Cette classe est la classe qui gere la pile. Cette classe implemente la 
 * classe actionListener, c'est donc elle qui servira a gerer les evenements des boutons qu'elle contient.
 *
 * @version 1.14
 * @since 5/11/05
 * @author Olivio_Mariano
 */

class Stack{

    private LinkedList neither;
    private int sizeof;

/** Constructeur de la pile avec une liste chainee
 * 
 * @param sizeoff
 */
    public Stack(int sizeoff){
    	neither = new LinkedList();
	this.sizeof = sizeoff;
    }
    
    /**
     * Methode associee au bouton d'ajout d'element dans la pile 
     * et inclusion de l'exeption d'une pile pleine
     */
    public void inStack(Object element) throws FullStackException{
	if(neither.size() == sizeof){
	    throw (new FullStackException());
	}
	neither.add(element);
    }

    /**
     * Methode associee au bouton d'affichage d'un element au sommet
     * d'une pile et inclusion de l'exeption d'une pile qui est vide
     * 
     * @return Object top
     */
    public Object top() throws EmptyStackException{
	if(neither.isEmpty()){
	    throw (new EmptyStackException());
	}
	return neither.get(neither.size()-1);
    }

    /**
     * Methode associee au bouton de suppression d'element dans une pile
     * et inclusion de l'exeption d'une pile qui est vide
     *
     */
    public void outStack() throws EmptyStackException{
	if(neither.isEmpty()){
	    throw (new EmptyStackException());
	}
	neither.remove(neither.size()-1);
    }

    /**
     * Methode de verification d'une pile vide
     * @return boolean
     */
    public boolean empty(){
	return neither.isEmpty();
    }

    /**
     * Methode qui permet de transformer une pile en chaine de characteres
     * @return String
     */
    public String toString(){
	return neither.toString();
    }
	
    /**
     * Methode d'iteration de pile
     * @return Iterator
     */
    public Iterator iterator(){
	return (new StackIterator(this));
    }

    /**
     * Methode qui retourne un espace
     * @return LinkedList
     */
    public LinkedList getNeither(){
	return neither;
    }

}
